Index: src/mlx/rpccommon.py
===================================================================
--- src/mlx/rpccommon.py	(revision 742)
+++ src/mlx/rpccommon.py	(revision 742)
@@ -0,0 +1,93 @@
+# Some common objects for RPC communication
+
+#------------------------------------------------------------------------------
+
+import const
+
+#------------------------------------------------------------------------------
+
+class Plane(object):
+    """Information about an airplane in the fleet."""
+    @staticmethod
+    def str2status(letter):
+        """Convert the given letter into a plane status."""
+        return const.PLANE_HOME if letter=="H" else \
+               const.PLANE_AWAY if letter=="A" else \
+               const.PLANE_PARKING if letter=="P" else \
+               const.PLANE_UNKNOWN
+
+    @staticmethod
+    def status2str(status):
+        """Convert the given status into the corresponding letter code."""
+        return "H" if status==const.PLANE_HOME else \
+               "A" if status==const.PLANE_AWAY else \
+               "P" if status==const.PLANE_PARKING else ""
+
+    def _setStatus(self, letter):
+        """Set the status from the given letter."""
+        self.status = Plane.str2status(letter)
+
+    def __repr__(self):
+        """Get the representation of the plane object."""
+        s = "<Plane: %s %s" % (self.tailNumber,
+                               "home" if self.status==const.PLANE_HOME else \
+                               "away" if self.status==const.PLANE_AWAY else \
+                               "parking" if self.status==const.PLANE_PARKING \
+                               else "unknown")
+        if self.gateNumber is not None:
+            s += " (gate " + self.gateNumber + ")"
+        s += ">"
+        return s
+
+#------------------------------------------------------------------------------
+
+class Fleet(object):
+    """Information about the whole fleet."""
+    def __init__(self):
+        """Construct the fleet information by reading the given file object."""
+        self._planes = {}
+
+    def isGateConflicting(self, plane):
+        """Check if the gate of the given plane conflicts with another plane's
+        position."""
+        for p in self._planes.itervalues():
+            if p.tailNumber!=plane.tailNumber and \
+               p.status==const.PLANE_HOME and \
+               p.gateNumber==plane.gateNumber:
+                return True
+
+        return False
+
+    def getOccupiedGateNumbers(self):
+        """Get a set containing the numbers of the gates occupied by planes."""
+        gateNumbers = set()
+        for p in self._planes.itervalues():
+            if p.status==const.PLANE_HOME and p.gateNumber:
+                gateNumbers.add(p.gateNumber)
+        return gateNumbers
+
+    def updatePlane(self, tailNumber, status, gateNumber = None):
+        """Update the status of the given plane."""
+        if tailNumber in self._planes:
+            plane = self._planes[tailNumber]
+            plane.status = status
+            plane.gateNumber = gateNumber
+
+    def _addPlane(self, plane):
+        """Add the given plane to the fleet."""
+        self._planes[plane.tailNumber] = plane
+
+    def __iter__(self):
+        """Get an iterator over the planes."""
+        for plane in self._planes.itervalues():
+            yield plane
+
+    def __getitem__(self, tailNumber):
+        """Get the plane with the given tail number.
+
+        If the plane is not in the fleet, None is returned."""
+        return self._planes[tailNumber] if tailNumber in self._planes else None
+
+    def __repr__(self):
+        """Get the representation of the fleet object."""
+        return self._planes.__repr__()
Index: src/mlx/web.py
===================================================================
--- src/mlx/web.py	(revision 570)
+++ src/mlx/web.py	(revision 764)
@@ -2,4 +2,9 @@
 import const
 import util
+from rpc import Registration
+import rpc
+import rpccommon
+
+from common import MAVA_BASE_URL
 
 import threading
@@ -255,5 +260,5 @@
 #------------------------------------------------------------------------------
 
-class Plane(object):
+class Plane(rpccommon.Plane):
     """Information about an airplane in the fleet."""
     def __init__(self, s):
@@ -263,4 +268,6 @@
         The first field is the tail number, the second field is the gate
         number, the third field is the plane's status as a character."""
+        super(Plane, self).__init__()
+
         try:
             words = s.split(" ")
@@ -269,8 +276,5 @@
 
             status = words[2] if len(words)>2 else None
-            self.status = const.PLANE_HOME if status=="H" else \
-                          const.PLANE_AWAY if status=="A" else \
-                          const.PLANE_PARKING if status=="P" else \
-                          const.PLANE_UNKNOWN
+            self._setStatus(status)
 
             gateNumber = words[1] if len(words)>1 else ""
@@ -281,24 +285,12 @@
             self.tailNumber = None
 
-    def __repr__(self):
-        """Get the representation of the plane object."""
-        s = "<Plane: %s %s" % (self.tailNumber,
-                               "home" if self.status==const.PLANE_HOME else \
-                               "away" if self.status==const.PLANE_AWAY else \
-                               "parking" if self.status==const.PLANE_PARKING \
-                               else "unknown")
-        if self.gateNumber is not None:
-            s += " (gate " + self.gateNumber + ")"
-        s += ">"
-        return s
-
-
-#------------------------------------------------------------------------------
-
-class Fleet(object):
+#------------------------------------------------------------------------------
+
+class Fleet(rpccommon.Fleet):
     """Information about the whole fleet."""
     def __init__(self, f):
         """Construct the fleet information by reading the given file object."""
-        self._planes = {}
+        super(Fleet, self).__init__()
+
         while True:
             line = readline(f)
@@ -306,47 +298,5 @@
 
             plane = Plane(line)
-            if plane.tailNumber is not None:
-                self._planes[plane.tailNumber] = plane
-
-    def isGateConflicting(self, plane):
-        """Check if the gate of the given plane conflicts with another plane's
-        position."""
-        for p in self._planes.itervalues():
-            if p.tailNumber!=plane.tailNumber and \
-               p.status==const.PLANE_HOME and \
-               p.gateNumber==plane.gateNumber:
-                return True
-
-        return False
-
-    def getOccupiedGateNumbers(self):
-        """Get a set containing the numbers of the gates occupied by planes."""
-        gateNumbers = set()
-        for p in self._planes.itervalues():
-            if p.status==const.PLANE_HOME and p.gateNumber:
-                gateNumbers.add(p.gateNumber)
-        return gateNumbers
-
-    def updatePlane(self, tailNumber, status, gateNumber = None):
-        """Update the status of the given plane."""
-        if tailNumber in self._planes:
-            plane = self._planes[tailNumber]
-            plane.status = status
-            plane.gateNumber = gateNumber
-
-    def __iter__(self):
-        """Get an iterator over the planes."""
-        for plane in self._planes.itervalues():
-            yield plane
-
-    def __getitem__(self, tailNumber):
-        """Get the plane with the given tail number.
-
-        If the plane is not in the fleet, None is returned."""
-        return self._planes[tailNumber] if tailNumber in self._planes else None
-
-    def __repr__(self):
-        """Get the representation of the fleet object."""
-        return self._planes.__repr__()
+            self._addPlane(plane)
 
 #------------------------------------------------------------------------------
@@ -663,9 +613,51 @@
 #------------------------------------------------------------------------------
 
+class RPCRequest(Request):
+    """Common base class for RPC requests.
+
+    It stores the RPC client received from the handler."""
+    def __init__(self, client, callback):
+        """Construct the request."""
+        super(RPCRequest, self).__init__(callback)
+        self._client = client
+
+#------------------------------------------------------------------------------
+
+class Register(RPCRequest):
+    """A registration request."""
+    def __init__(self, client, callback, registrationData):
+        """Construct the request."""
+        super(Register, self).__init__(client, callback)
+        self._registrationData = registrationData
+
+    def run(self):
+        """Perform the registration."""
+
+        registrationData = self._registrationData
+
+        (resultCode, pilotID) = self._client.register(registrationData)
+        result = Result()
+        result.registered = resultCode==rpc.Client.RESULT_OK
+        if result.registered:
+            result.pilotID = pilotID
+
+            self._client.setCredentials(pilotID, registrationData.password)
+            loginResult = self._client.login()
+            result.loggedIn = loginResult is not None
+
+        result.invalidData = \
+          resultCode==rpc.Client.RESULT_INVALID_DATA
+        result.emailAlreadyRegistered = \
+          resultCode==rpc.Client.RESULT_EMAIL_ALREADY_REGISTERED
+
+        return result
+
+#------------------------------------------------------------------------------
+
 class Login(Request):
     """A login request."""
     iso88592decoder = codecs.getdecoder("iso-8859-2")
 
-    def __init__(self, callback, pilotID, password, entranceExam):
+    def __init__(self, callback, pilotID, password):
         """Construct the login request with the given pilot ID and
         password."""
@@ -674,5 +666,4 @@
         self._pilotID = pilotID
         self._password = password
-        self._entranceExam = entranceExam
 
     def run(self):
@@ -686,43 +677,29 @@
         password = md5.hexdigest()
 
-        if self._entranceExam:
-            url = "http://www.virtualairlines.hu/ellenorzo/getflightplan.php?pid=%s" % \
-                  (pilotID,)
-        else:
-            url = "http://www.virtualairlines.hu/leker2.php?pid=%s&psw=%s" % \
-                  (pilotID, password)
+        url = MAVA_BASE_URL + "/leker2.php?pid=%s&psw=%s" %  (pilotID, password)
 
         result = Result()
-        result.entranceExam = self._entranceExam
 
         f = urllib2.urlopen(url, timeout = 10.0)
 
         status = readline(f)
-        if self._entranceExam:
-            result.loggedIn = status != "#NOEXAM"
-        else:
-            result.loggedIn = status == ".OK."
+        result.loggedIn = status == ".OK."
 
         if result.loggedIn:
             result.pilotID = self._pilotID
             result.password = self._password
+            result.rank = "FO"
             result.flights = []
-            # FIXME: this may not be the correct behaviour
-            # for an entrance exam, but the website returns
-            # an error
-            if self._entranceExam:
-                result.pilotName = result.pilotID
-                result.exams = ""
-            else:
-                result.pilotName = self.iso88592decoder(readline(f))[0]
-                result.exams = readline(f)
-
-                while True:
-                    line = readline(f)
-                    if not line or line == "#ENDPIREP": break
-
-                    flight = BookedFlight(line)
-                    flight.readFromWeb(f)
-                    result.flights.append(flight)
+
+            result.pilotName = self.iso88592decoder(readline(f))[0]
+            result.exams = readline(f)
+
+            while True:
+                line = readline(f)
+                if not line or line == "#ENDPIREP": break
+
+                flight = BookedFlight(line)
+                flight.readFromWeb(f)
+                result.flights.append(flight)
 
             result.flights.sort(cmp = lambda flight1, flight2:
@@ -736,4 +713,57 @@
 #------------------------------------------------------------------------------
 
+class LoginRPC(RPCRequest):
+    """An RPC-based login request."""
+    def __init__(self, client, callback, pilotID, password):
+        """Construct the login request with the given pilot ID and
+        password."""
+        super(LoginRPC, self).__init__(client, callback)
+
+        self._pilotID = pilotID
+        self._password = password
+
+    def run(self):
+        """Perform the login request."""
+        result = Result()
+
+        self._client.setCredentials(self._pilotID, self._password)
+        loginResult = self._client.login()
+        result.loggedIn = loginResult is not None
+        if result.loggedIn:
+            result.pilotID = self._pilotID
+            result.pilotName = loginResult[0]
+            result.rank = loginResult[1]
+            result.password = self._password
+            result.flights = self._client.getFlights()
+            if result.rank=="STU":
+                reply = self._client.getEntryExamStatus()
+                result.entryExamPassed = reply[0]
+                result.entryExamLink = reply[1]
+                result.checkFlightStatus = reply[2]
+
+        return result
+
+#------------------------------------------------------------------------------
+
+class GetEntryExamStatus(RPCRequest):
+    """A request to get the entry exam status."""
+    def __init__(self, client, callback):
+        """Construct the request."""
+        super(GetEntryExamStatus, self).__init__(client, callback)
+
+    def run(self):
+        """Perform the query."""
+        result = Result()
+
+        reply = self._client.getEntryExamStatus()
+
+        result.entryExamPassed = reply[0]
+        result.entryExamLink = reply[1]
+        result.checkFlightStatus = reply[2]
+
+        return result
+
+#------------------------------------------------------------------------------
+
 class GetFleet(Request):
     """Request to get the fleet from the website."""
@@ -745,5 +775,5 @@
     def run(self):
         """Perform the login request."""
-        url = "http://www.virtualairlines.hu/onlinegates_get.php"
+        url = MAVA_BASE_URL + "/onlinegates_get.php"
 
         f = urllib2.urlopen(url, timeout = 10.0)
@@ -751,4 +781,20 @@
         result.fleet = Fleet(f)
         f.close()
+
+        return result
+
+#------------------------------------------------------------------------------
+
+class GetFleetRPC(RPCRequest):
+    """Request to get the fleet from the website using RPC."""
+    def __init__(self, client, callback):
+        """Construct the request with the given client and callback function."""
+        super(GetFleetRPC, self).__init__(client, callback)
+
+    def run(self):
+        """Perform the login request."""
+        result = Result()
+
+        result.fleet = self._client.getFleet()
 
         return result
@@ -767,9 +813,7 @@
     def run(self):
         """Perform the plane update."""
-        url = "http://www.virtualairlines.hu/onlinegates_set.php"
-
-        status = "H" if self._status==const.PLANE_HOME else \
-                 "A" if self._status==const.PLANE_AWAY else \
-                 "P" if self._status==const.PLANE_PARKING else ""
+        url = MAVA_BASE_URL + "/onlinegates_set.php"
+
+        status = Plane.status2str(self._status)
 
         gateNumber = self._gateNumber if self._gateNumber else ""
@@ -784,4 +828,26 @@
         result = Result()
         result.success = line == "OK"
+
+        return result
+
+#------------------------------------------------------------------------------
+
+class UpdatePlaneRPC(RPCRequest):
+    """RPC request to update the status and the position of a plane in the
+    fleet."""
+    def __init__(self, client, callback, tailNumber, status, gateNumber = None):
+        """Construct the request."""
+        super(UpdatePlaneRPC, self).__init__(client, callback)
+        self._tailNumber = tailNumber
+        self._status = status
+        self._gateNumber = gateNumber
+
+    def run(self):
+        """Perform the plane update."""
+        self._client.updatePlane(self._tailNumber, self._status, self._gateNumber)
+
+        # Otherwise an exception is thrown
+        result = Result()
+        result.success = True
 
         return result
@@ -898,9 +964,4 @@
 class SendPIREP(Request):
     """A request to send a PIREP to the MAVA website."""
-    _flightTypes = { const.FLIGHTTYPE_SCHEDULED : "SCHEDULED",
-                     const.FLIGHTTYPE_OLDTIMER : "OT",
-                     const.FLIGHTTYPE_VIP : "VIP",
-                     const.FLIGHTTYPE_CHARTER : "CHARTER" }
-
     _latin2Encoder = codecs.getencoder("iso-8859-2")
 
@@ -912,6 +973,5 @@
     def run(self):
         """Perform the sending of the PIREP."""
-        url = "http://www.virtualairlines.hu/malevacars.php"
-        #url = "http://localhost:15000"
+        url = MAVA_BASE_URL + "/malevacars.php"
 
         pirep = self._pirep
@@ -932,5 +992,5 @@
         data["mail"] = str(pirep.mailWeight)
 
-        data["flttype"] = SendPIREP._flightTypes[pirep.flightType]
+        data["flttype"] = pirep.flightTypeText
         data["onoff"] = "1" if pirep.online else "0"
         data["bt_dep"] = util.getTimestampString(pirep.blockTimeStart)
@@ -980,4 +1040,26 @@
 #------------------------------------------------------------------------------
 
+class SendPIREPRPC(RPCRequest):
+    """A request to send a PIREP to the MAVA website via the RPC interface."""
+
+    def __init__(self, client, callback, pirep):
+        """Construct the sending of the PIREP."""
+        super(SendPIREPRPC, self).__init__(client, callback)
+        self._pirep = pirep
+
+    def run(self):
+        """Perform the sending of the PIREP."""
+        pirep = self._pirep
+        resultCode = self._client.addPIREP(pirep.bookedFlight.id, pirep)
+
+        result = Result()
+        result.success = resultCode==rpc.Client.RESULT_OK
+        result.alreadyFlown = resultCode==rpc.Client.RESULT_FLIGHT_ALREADY_REPORTED
+        result.notAvailable = resultCode==rpc.Client.RESULT_FLIGHT_NOT_EXISTS
+
+        return result
+
+#------------------------------------------------------------------------------
+
 class SendACARS(Request):
     """A request to send an ACARS to the MAVA website."""
@@ -993,5 +1075,5 @@
         print "Sending the online ACARS"
 
-        url = "http://www.virtualairlines.hu/acars2/acarsonline.php"
+        url = MAVA_BASE_URL  + "/acars2/acarsonline.php"
 
         acars = self._acars
@@ -1027,4 +1109,20 @@
 #------------------------------------------------------------------------------
 
+class SendACARSRPC(RPCRequest):
+    """A request to send an ACARS to the MAVA website via JSON-RPC."""
+    def __init__(self, client, callback, acars):
+        """Construct the request for the given PIREP."""
+        super(SendACARSRPC, self).__init__(client, callback)
+        self._acars = acars
+
+    def run(self):
+        """Perform the sending of the ACARS."""
+        print "Sending the online ACARS via JSON-RPC"
+
+        self._client.updateOnlineACARS(self._acars)
+        return Result()
+
+#------------------------------------------------------------------------------
+
 class SendBugReport(Request):
     """A request to send a bug report to the project homepage."""
@@ -1063,5 +1161,5 @@
     It can process one request at a time. The results are passed to a callback
     function."""
-    def __init__(self):
+    def __init__(self, config, getCredentialsFn):
         """Construct the handler."""
         super(Handler, self).__init__()
@@ -1071,16 +1169,40 @@
 
         self.daemon = True
-
-    def login(self, callback, pilotID, password, entranceExam = False):
+        self._config = config
+        self._rpcClient = rpc.Client(getCredentialsFn)
+        if config.rememberPassword:
+            self._rpcClient.setCredentials(config.pilotID, config.password)
+
+    def register(self, callback, registrationData):
+        """Enqueue a registration request."""
+        self._addRequest(Register(self._rpcClient, callback, registrationData))
+
+    def login(self, callback, pilotID, password):
         """Enqueue a login request."""
-        self._addRequest(Login(callback, pilotID, password, entranceExam))
+        request = \
+          LoginRPC(self._rpcClient, callback, pilotID, password) \
+          if self._config.useRPC else Login(callback, pilotID, password)
+
+        self._addRequest(request)
+
+    def getEntryExamStatus(self, callback):
+        """Get the entry exam status."""
+        self._addRequest(GetEntryExamStatus(self._rpcClient, callback))
 
     def getFleet(self, callback):
         """Enqueue a fleet retrieval request."""
-        self._addRequest(GetFleet(callback))
+        request = \
+          GetFleetRPC(self._rpcClient, callback,) if self._config.useRPC \
+          else GetFleet(callback)
+        self._addRequest(request)
 
     def updatePlane(self, callback, tailNumber, status, gateNumber = None):
         """Update the status of the given plane."""
-        self._addRequest(UpdatePlane(callback, tailNumber, status, gateNumber))
+        request = \
+          UpdatePlaneRPC(self._rpcClient, callback,
+                         tailNumber, status, gateNumber) \
+          if self._config.useRPC \
+          else UpdatePlane(callback, tailNumber, status, gateNumber)
+        self._addRequest(request)
 
     def getNOTAMs(self, callback, departureICAO, arrivalICAO):
@@ -1094,9 +1216,15 @@
     def sendPIREP(self, callback, pirep):
         """Send the given PIREP."""
-        self._addRequest(SendPIREP(callback, pirep))
+        request = \
+          SendPIREPRPC(self._rpcClient, callback, pirep) if self._config.useRPC \
+          else SendPIREP(callback, pirep)
+        self._addRequest(request)
 
     def sendACARS(self, callback, acars):
         """Send the given ACARS"""
-        self._addRequest(SendACARS(callback, acars))
+        request = \
+          SendACARSRPC(self._rpcClient, callback, acars) if self._config.useRPC \
+          else SendACARS(callback, acars)
+        self._addRequest(request)
 
     def sendBugReport(self, callback, summary, description, email):
